Weblate 的 REST API¶
The API is accessible on the /api/ URL and it is based on
Django REST framework.
You can use it directly or by Weblate 用戶端.
See Libraries and SDKs for official tools and community-maintained integrations.
還用 /api/schema/ URL 上的 OpenAPI 3.1 記錄了該 API,您可以存取 /api/docs/ 進行瀏覽。
身分驗證和通用參數¶
唯讀 API 無需身分驗證即可使用,除非開啟了 REQUIRE_LOGIN 設定。但未經身分驗證的請求會受到嚴格的限制(預設為每天 100 個請求),所以建議使用身分驗證。
驗證時會使用權杖,可在個人資料中取得。請在 Authorization 標頭中使用 Token 或 Bearer 配置。即使是公開端點,或您已透過瀏覽器工作階段登入,不支援的配置(例如 Basic)仍會傳回 401 Unauthorized。
- ANY /¶
Generic request behaviour for the API, the headers, status codes and parameters here apply to all endpoints as well.
- Query Parameters:
format -- Response format (overrides Accept). Possible values depend on REST framework setup, by default
json,csvandapiare supported. The latter provides a web browser interface for the API.page -- Returns given page of paginated results (use next and previous fields in response to automate the navigation).
page_size -- Return the given number of items per request. The default is 50 and the maximum is 1000. For the units endpoints the default is 100 with a maximum of 10000. The default value is also configurable using the PAGE_SIZE setting.
- Request Headers:
Accept -- the response content type depends on Accept header
Authorization -- optional token to authenticate as
Authorization: Token YOUR-TOKEN
- Response Headers:
Content-Type -- this depends on Accept header of request
Allow -- list of allowed HTTP methods on object
- Request JSON Object:
detail (string) -- verbose description of the result (for HTTP status codes other than 200 OK)
count (int) -- total item count for object lists
next (string) -- next page URL for object lists
previous (string) -- previous page URL for object lists
results (array) -- results for object lists
url (string) -- URL to access this resource using the API
web_url (string) -- URL to access this resource using web browser
- Status Codes:
200 OK -- when request was correctly handled
201 Created -- when a new object was created successfully
204 No Content -- when an object was deleted successfully
400 Bad Request -- when form parameters are missing
401 Unauthorized -- when authentication credentials are invalid or the authentication scheme is unsupported
403 Forbidden -- when access is denied
429 Too Many Requests -- when throttling is in place
身分驗證權杖¶
在 4.10 版的變更: 專案範圍權杖在 4.10 版本中引入。
每個使用者都有自己的個人存取權杖,可以在使用者檔案中獲得。新產生的使用者存取權杖帶有 wlu_ 字首。
可以建立專案範圍的存取權杖,只用於存取指定專案的 API。這些存取權杖帶有 wlp_ 字首。
身分驗證範例¶
典型請求:
GET /api/ HTTP/1.1
Host: example.com
Accept: application/json, text/javascript
Authorization: Token YOUR-TOKEN
典型回應:
HTTP/1.0 200 OK
Date: Fri, 25 Mar 2016 09:46:12 GMT
Server: WSGIServer/0.1 Python/2.7.11+
Vary: Accept, Accept-Language, Cookie
X-Frame-Options: SAMEORIGIN
Content-Type: application/json
Content-Language: en
Allow: GET, HEAD, OPTIONS
{
"projects":"http://example.com/api/projects/",
"components":"http://example.com/api/components/",
"translations":"http://example.com/api/translations/",
"languages":"http://example.com/api/languages/"
}
CURL 範例:
curl \
-H "Authorization: Token TOKEN" \
https://example.com/api/
傳遞參數範例¶
對於 POST 方法,參數可以指定為表格提交(application/x-www-form-urlencoded)或 JSON (application/json)。
表單請求範例:
POST /api/projects/hello/repository/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/x-www-form-urlencoded
Authorization: Token TOKEN
operation=pull
JSON 請求範例:
POST /api/projects/hello/repository/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN
Content-Length: 20
{"operation":"pull"}
CURL 範例:
curl \
-d operation=pull \
-H "Authorization: Token TOKEN" \
http://example.com/api/components/hello/weblate/repository/
CURL JSON 範例:
curl \
--data-binary '{"operation":"pull"}' \
-H "Content-Type: application/json" \
-H "Authorization: Token TOKEN" \
http://example.com/api/components/hello/weblate/repository/
組件與類別¶
若要存取巢狀於 類別 中的組件,您必須將分類名稱進行 URL 編碼,成為以斜線分隔的組件名稱。例如,docs 分類中的 usage 必須寫成 docs%252Fusage;完整 URL 會是 https://example.com/api/components/hello/docs%252Fusage/repository/。
API 速率限制¶
這個 API 請求限制了速率;對於匿名使用者預設設定限制為每天 100 個請求,對於身分驗證的使用者限制為每小時 5000 個請求。
使用 settings.py 中的 API_RATELIMIT_ANON 和 API_RATELIMIT_USER 設定預設限制。
在 Docker 容器中可使用 WEBLATE_API_RATELIMIT_ANON 和 WEBLATE_API_RATELIMIT_USER 對此進行設定。
使用 API_RATELIMIT_USER_OVERRIDES 為自動化帳號設定不同限制。使用 API_RATELIMIT_IP_OVERRIDES 為個別 IP 位址或網路(包括匿名 CI 用戶端)設定不同限制:
API_RATELIMIT_USER_OVERRIDES = {"automation": "20000/hour"}
API_RATELIMIT_IP_OVERRIDES = {
"192.0.2.42": None,
"198.51.100.0/24": "10000/hour",
"2001:db8::/48": "10000/hour",
}
明確的使用者名稱覆寫規則優先於 IP 規則。否則,會套用最具體的相符網路;單一位址等同於只包含一個位址的網路。設為 None 可豁免相符請求的 API 速率限制,包括匿名限制。驗證和權限仍會套用;豁免限制不會授予存取私有專案或執行寫入操作的權限。
已驗證請求按使用者計數,匿名請求則按用戶端 IP 計數。同一網路中的用戶端不會共用同一個額度。每條覆寫規則和每種速率都有各自的額度;變更規則或速率會開始新的額度。沒有覆寫規則的請求會使用預設限制。
IP 規則會使用 Weblate 判定的用戶端位址。若位於反向 Proxy 後方,請正確設定 IP_BEHIND_REVERSE_PROXY、IP_PROXY_HEADER 和 IP_PROXY_OFFSET。受信任的 Proxy 必須提供用戶端位址,而且不受信任的用戶端不能繞過這項設定。若豁免共用 Proxy 的位址,可能會讓所有使用該 Proxy 的用戶端都獲得豁免。
在 Docker 中,請使用 WEBLATE_API_RATELIMIT_USER_OVERRIDES 和 WEBLATE_API_RATELIMIT_IP_OVERRIDES 設定對應的 JSON 對應。豁免限制請使用 JSON null。
速率限制在後面的標頭中報告:
|
允許執行的請求數 |
|
剩餘的執行請求數 |
|
直到速率限制視窗重設時的秒數 |
豁免速率限制的請求不會包含這些標頭。
在 4.1 版的變更: 新增了速率限制狀態標頭。
錯誤回應¶
在 5.10 版的變更: 此版本前不同端點的錯誤回應不一樣。
Weblate 錯誤回應格式依據 Error Response Format。
API 入口點¶
- GET /api/¶
The API root entry point.
典型請求:
GET /api/ HTTP/1.1 Host: example.com Accept: application/json, text/javascript Authorization: Token YOUR-TOKEN
典型回應:
HTTP/1.0 200 OK Date: Fri, 25 Mar 2016 09:46:12 GMT Server: WSGIServer/0.1 Python/2.7.11+ Vary: Accept, Accept-Language, Cookie X-Frame-Options: SAMEORIGIN Content-Type: application/json Content-Language: en Allow: GET, HEAD, OPTIONS { "projects":"http://example.com/api/projects/", "components":"http://example.com/api/components/", "translations":"http://example.com/api/translations/", "languages":"http://example.com/api/languages/" }
使用者¶
在 4.0 版被加入.
- GET /api/users/¶
Returns no results to unauthenticated users. Authenticated users without the global
user.vieworuser.editpermission see only their own basic details when listing without a username filter. They can search for other users by supplying a username prefix of at least two characters after trimming surrounding whitespace; these searches return the user ID, username, and full name of matching non-bot users. Users with either permission can list all users and receive detailed information.- Query Parameters:
username (string) -- Username prefix to search for. At least two characters after trimming surrounding whitespace are required for users without the global
user.vieworuser.editpermission.id (int) -- User ID to search for
email (string) -- Email to search for (case-insensitive, exact match). Requires
user.vieworuser.editpermission; the parameter is ignored for unprivileged users.
Username searches by users without the global
user.vieworuser.editpermission exclude bot accounts other than the caller's own account.也參考
Users object attributes are documented at
GET /api/users/(str:username)/.
- POST /api/users/¶
Creates a new user.
Requires the global
user.editpermission. See 存取控制 for the user management permission model.- 參數:
username (string) -- 使用者名稱
full_name (string) -- User full name
email (string) -- User email
is_superuser (boolean) -- Is user superuser? (optional)
is_active (boolean) -- Is user active? (optional)
is_bot (boolean) -- Is user bot? (optional) (used for project scoped tokens)
- GET /api/users/(str: username)/¶
Returns information about users.
- 參數:
username (string) -- User's username
- Request JSON Object:
username (string) -- username of a user
full_name (string) -- full name of a user
email (string) -- email of a user
is_superuser (boolean) -- whether the user is a super user
is_active (boolean) -- whether the user is active
is_bot (boolean) -- whether the user is bot (used for project scoped tokens)
date_joined (string) -- date the user is created
last_login (string) -- date the user last signed in
groups (array) -- link to associated groups; see
GET /api/groups/(int:id)/profile (object) -- user profile preferences; see 使用者設定檔. Returned only with the
user.vieworuser.editpermission.
Example JSON data:
{ "email": "user@example.com", "full_name": "Example User", "username": "exampleusername", "groups": [ "http://example.com/api/groups/2/", "http://example.com/api/groups/3/" ], "profile": { "language": "en", "languages": [ "http://example.com/api/languages/cs/" ], "secondary_languages": [], "translated": 42, "suggested": 3, "uploaded": 1, "commented": 5, "theme": "auto", "hide_completed": false, "secondary_in_zen": true, "hide_source_secondary": false, "wide_tables": false, "listing_columns": ["untranslated", "untranslated_words", "untranslated_chars", "nottranslated", "checks", "suggestions", "comments"], "editor_link": "", "translate_mode": 0, "zen_mode": 0, "special_chars": "", "nearby_strings": 10, "auto_watch": true, "contribute_personal_tm": true, "dashboard_view": 1, "dashboard_component_list": null, "watched": [], "website": "https://example.com/", "contact": "", "liberapay": "", "fediverse": "", "codesite": "", "github": "", "twitter": "", "linkedin": "", "location": "", "company": "", "public_email": "", "commit_email": "", "commit_name": 0, "last_2fa": "" }, "is_superuser": true, "is_active": true, "is_bot": false, "date_joined": "2020-03-29T18:42:42.617681Z", "url": "http://example.com/api/users/exampleusername/", "contributions_url": "http://example.com/api/users/exampleusername/contributions/", "statistics_url": "http://example.com/api/users/exampleusername/statistics/" }
- PUT /api/users/(str: username)/¶
Changes the user parameters.
Requires the global
user.editpermission unless a user is updating their own account or profile fields. See 存取控制 for the user management permission model.- 參數:
username (string) -- User's username
- Request JSON Object:
username (string) -- username of a user
full_name (string) -- full name of a user
email (string) -- email of a user
is_superuser (boolean) -- whether the user is a super user
is_active (boolean) -- whether the user is active
is_bot (boolean) -- whether the user is bot (used for project scoped tokens)
date_joined (string) -- date the user is created
profile (object) -- updated profile preferences when included in the request; see 使用者設定檔
- PATCH /api/users/(str: username)/¶
Changes the user parameters.
Requires the global
user.editpermission unless a user is updating their own account or profile fields. See 存取控制 for the user management permission model.- 參數:
username (string) -- User's username
- Request JSON Object:
username (string) -- username of a user
full_name (string) -- full name of a user
email (string) -- email of a user
is_superuser (boolean) -- whether the user is a super user
is_active (boolean) -- whether the user is active
is_bot (boolean) -- whether the user is bot (used for project scoped tokens)
date_joined (string) -- date the user is created
profile (object) -- updated profile preferences when included in the request; see 使用者設定檔
- DELETE /api/users/(str: username)/¶
Deletes all user information and marks the user inactive.
Requires the global
user.editpermission. See 存取控制 for the user management permission model.- 參數:
username (string) -- User's username
- POST /api/users/(str: username)/groups/¶
Associate groups with a user.
Requires the global
user.editpermission. See 存取控制 for the user management permission model. This permission authorizes membership changes for every team, including project and workspace teams; no separate permission over the target team is required.- 參數:
username (string) -- User's username
- Form Parameters:
string group_id -- The unique group ID
- DELETE /api/users/(str: username)/groups/¶
在 4.13.1 版被加入.
Remove user from a group.
Requires the global
user.editpermission. See 存取控制 for the user management permission model. This permission authorizes membership changes for every team, including project and workspace teams; no separate permission over the target team is required.- 參數:
username (string) -- User's username
- Form Parameters:
string group_id -- The unique group ID
- GET /api/users/(str: username)/statistics/¶
List statistics of a user.
- 參數:
username (string) -- User's username
- Request JSON Object:
translated (int) -- Number of translations by user
suggested (int) -- Number of suggestions by user
uploaded (int) -- Number of uploads by user
commented (int) -- Number of comments by user
languages (int) -- Number of languages user can translate
- GET /api/users/(str: username)/contributions/¶
List translations with contributions from a user.
- 參數:
username (string) -- User's username
- Request JSON Object:
translations (array) -- link to translations; see
GET /api/translations/(string:project)/(string:component)/(string:language)/
- GET /api/users/(str: username)/notifications/¶
List subscriptions of a user.
- 參數:
username (string) -- User's username
- Request JSON Object:
project (string) -- Link to the project, or
nullfor other scopescomponent (string) -- Link to the component, or
nullfor other scopes
- POST /api/users/(str: username)/notifications/¶
Associate subscriptions with a user.
- 參數:
username (string) -- User's username
- Response JSON Object:
notification (string) -- Name of notification registered
scope (int) -- Scope of notification from the available choices
frequency (int) -- Frequency choices for notifications
- GET /api/users/(str: username)/notifications/(int: subscription_id)/¶
Get a subscription associated with a user.
- 參數:
username (string) -- User's username
subscription_id (int) -- ID of notification registered
- Request JSON Object:
project (string) -- Link to the project, or
nullfor other scopescomponent (string) -- Link to the component, or
nullfor other scopes
- PUT /api/users/(str: username)/notifications/(int: subscription_id)/¶
Edit a subscription associated with a user.
- 參數:
username (string) -- User's username
subscription_id (int) -- ID of notification registered
- Response JSON Object:
notification (string) -- Name of notification registered
scope (int) -- Scope of notification from the available choices
frequency (int) -- Frequency choices for notifications
- PATCH /api/users/(str: username)/notifications/(int: subscription_id)/¶
Edit a subscription associated with a user.
- 參數:
username (string) -- User's username
subscription_id (int) -- ID of notification registered
- Response JSON Object:
notification (string) -- Name of notification registered
scope (int) -- Scope of notification from the available choices
frequency (int) -- Frequency choices for notifications
- DELETE /api/users/(str: username)/notifications/(int: subscription_id)/¶
Delete a subscription associated with a user.
- 參數:
username (string) -- User's username
subscription_id -- Name of notification registered
subscription_id -- int
使用者設定檔¶
在 2026.8 版被加入.
使用者 API 會在巢狀 profile 物件中公開設定檔偏好。只有具備 user.view 或 user.edit 權限的呼叫者,才能在 GET /api/users/(str:username)/ 的回應中取得此物件。沒有這些權限的使用者仍可透過 PATCH /api/users/(str:username)/ 更新自己的設定檔;回應接著會包含更新後的 profile 物件。
設定檔欄位會對應 使用者設定檔 中所述的設定。
群組¶
在 4.0 版被加入.
變更全站群組的存取範圍需要全域的 group.edit 權限。這項需要高度信任的管理權限,不受呼叫者的專案存取權限制:專案和組件關聯端點可授予團隊成員私密專案的存取權,即使呼叫者無法直接存取那些專案。請參閱全站團隊管理,瞭解權限模型及範圍較小的委派選項。
- GET /api/groups/¶
Returns a list of groups if you have permissions to see manage groups. If not, then you get to see only the groups the user is a part of.
也參考
Group object attributes are documented at
GET /api/groups/(int:id)/.
- POST /api/groups/¶
Creates a new group.
- 參數:
name (string) -- Group name
project_selection (int) -- Group of project selection from given options
language_selection (int) -- Group of languages selected from given options
defining_project (str) -- link to the defining project, used for 管理個別專案存取控制; see
GET /api/projects/(string:project)/
- GET /api/groups/(int: id)/¶
Returns information about the group.
- 參數:
id (int) -- Group's ID
- Request JSON Object:
name (string) -- name of a group
project_selection (int) -- integer corresponding to group of projects
language_selection (int) -- integer corresponding to group of languages
roles (array) -- link to associated roles; see
GET /api/roles/(int:id)/projects (array) -- link to associated projects; see
GET /api/projects/(string:project)/components (array) -- link to associated components; see
GET /api/components/(string:project)/(string:component)/componentlists (array) -- link to associated componentlist; see
GET /api/component-lists/(str:slug)/defining_project (str) -- link to the defining project, used for 管理個別專案存取控制; see
GET /api/projects/(string:project)/admins (array) -- link to associated administrators; see
GET /api/users/(str:username)/
Example JSON data:
{ "name": "Guests", "defining_project": null, "project_selection": 3, "language_selection": 1, "url": "http://example.com/api/groups/1/", "roles": [ "http://example.com/api/roles/1/", "http://example.com/api/roles/2/" ], "languages": [ "http://example.com/api/languages/en/", "http://example.com/api/languages/cs/", ], "projects": [ "http://example.com/api/projects/demo1/", "http://example.com/api/projects/demo/" ], "componentlist": "http://example.com/api/component-lists/new/", "components": [ "http://example.com/api/components/demo/weblate/" ], "admins": [ "http://example.com/api/users/exampleusername/" ] }
- PUT /api/groups/(int: id)/¶
Changes the group parameters.
- 參數:
id (int) -- Group's ID
- Request JSON Object:
name (string) -- name of a group
project_selection (int) -- integer corresponding to group of projects
language_selection (int) -- integer corresponding to group of languages
- PATCH /api/groups/(int: id)/¶
Changes the group parameters.
- 參數:
id (int) -- Group's ID
- Request JSON Object:
name (string) -- name of a group
project_selection (int) -- integer corresponding to group of projects
language_selection (int) -- integer corresponding to group of languages
- DELETE /api/groups/(int: id)/¶
Deletes the group.
- 參數:
id (int) -- Group's ID
- POST /api/groups/(int: id)/roles/¶
Associate roles with a group.
- 參數:
id (int) -- Group's ID
- Form Parameters:
string role_id -- The unique role ID
- DELETE /api/groups/(int: id)/roles/(int: role_id)¶
Delete role from a group.
- 參數:
id (int) -- Group's ID
role_id (int) -- The unique role ID
- POST /api/groups/(int: id)/components/¶
Associate components with a group.
- 參數:
id (int) -- Group's ID
- Form Parameters:
string component_id -- The unique component ID
- DELETE /api/groups/(int: id)/components/(int: component_id)¶
Delete component from a group.
- 參數:
id (int) -- Group's ID
component_id (int) -- The unique component ID
- POST /api/groups/(int: id)/projects/¶
Associate projects with a group.
- 參數:
id (int) -- Group's ID
- Form Parameters:
string project_id -- The unique project ID
- DELETE /api/groups/(int: id)/projects/(int: project_id)¶
Delete project from a group.
- 參數:
id (int) -- Group's ID
project_id (int) -- The unique project ID
- POST /api/groups/(int: id)/languages/¶
Associate languages with a group.
- 參數:
id (int) -- Group's ID
- Form Parameters:
string language_code -- The unique language code
- DELETE /api/groups/(int: id)/languages/(string: language_code)¶
Delete language from a group.
- 參數:
id (int) -- Group's ID
language_code (string) -- The unique language code
- POST /api/groups/(int: id)/componentlists/¶
Associate componentlists with a group.
- 參數:
id (int) -- Group's ID
- Form Parameters:
string component_list_id -- The unique componentlist ID
- DELETE /api/groups/(int: id)/componentlists/(int: component_list_id)¶
Delete componentlist from a group.
- 參數:
id (int) -- Group's ID
component_list_id (int) -- The unique componentlist ID
- POST /api/groups/(int: id)/admins/¶
在 5.5 版被加入.
Add user to team admins.
- 參數:
id (int) -- Group's ID
- Form Parameters:
string user_id -- The user's ID
- DELETE /api/groups/(int: id)/admins/(int: user_id)¶
在 5.5 版被加入.
Delete user from team admins.
- 參數:
id (int) -- Group's ID
user_id (integer) -- The user's ID
角色¶
- GET /api/roles/¶
Returns a list of all roles associated with user. If user is superuser, then list of all existing roles is returned.
也參考
Roles object attributes are documented at
GET /api/roles/(int:id)/.
- POST /api/roles/¶
Creates a new role.
- 參數:
name (string) -- Role name
permissions (array) -- List of codenames of permissions
- GET /api/roles/(int: id)/¶
Returns information about the role.
- 參數:
id (int) -- Role's ID
- Request JSON Object:
name (string) -- Role name
permissions (array) -- list of codenames of permissions
Example JSON data:
{ "name": "Access repository", "permissions": [ "vcs.access", "vcs.view" ], "url": "http://example.com/api/roles/1/", }
- PUT /api/roles/(int: id)/¶
Changes the role parameters.
- 參數:
id (int) -- Role's ID
- Request JSON Object:
name (string) -- Role name
permissions (array) -- list of codenames of permissions
- PATCH /api/roles/(int: id)/¶
Changes the role parameters.
When supplied,
permissionsreplaces the role's complete permission set. Omit it to keep the existing permissions unchanged, or pass an empty list to remove all permissions.- 參數:
id (int) -- Role's ID
- Request JSON Object:
name (string) -- Role name
permissions (array) -- list of codenames of permissions
- DELETE /api/roles/(int: id)/¶
Deletes the role.
- 參數:
id (int) -- Role's ID
語言¶
- GET /api/languages/¶
Returns a list of all languages.
也參考
Language object attributes are documented at
GET /api/languages/(string:language)/.
- POST /api/languages/¶
Creates a new language.
- 參數:
code (string) -- 語言名稱
name (string) -- 語言名稱
direction (string) -- 文字方向
population (int) -- 語言使用者數量
plural (object) -- Language plural formula and number
- GET /api/languages/(string: language)/¶
Returns information about the language.
- 參數:
language (string) -- 語言代碼
- Request JSON Object:
code (string) -- 語言代碼
direction (string) -- 文字方向
plural (object) -- Object of language plural information
aliases (array) -- Array of aliases for language
- Response JSON Object:
population (int) -- 語言使用者數量
Example JSON data:
{ "code": "en", "direction": "ltr", "name": "English", "population": 159034349015, "plural": { "id": 75, "source": 0, "number": 2, "formula": "n != 1", "type": 1 }, "aliases": [ "english", "en_en", "base", "source", "eng" ], "url": "http://example.com/api/languages/en/", "web_url": "http://example.com/languages/en/", "statistics_url": "http://example.com/api/languages/en/statistics/" }
- PUT /api/languages/(string: language)/¶
Changes the language parameters.
- 參數:
language (string) -- Language's code
- Response JSON Object:
name (string) -- 語言名稱
direction (string) -- 文字方向
population (int) -- 語言使用者數量
plural (object) -- Language plural details
- PATCH /api/languages/(string: language)/¶
Changes the language parameters.
- 參數:
language (string) -- Language's code
- Response JSON Object:
name (string) -- 語言名稱
direction (string) -- 文字方向
population (int) -- 語言使用者數量
plural (object) -- Language plural details
- DELETE /api/languages/(string: language)/¶
Deletes the language.
- 參數:
language (string) -- Language's code
專案¶
- GET /api/projects/¶
Returns a list of all projects.
也參考
Project object attributes are documented at
GET /api/projects/(string:project)/.
- POST /api/projects/¶
Creates a new project.
- 參數:
name (string) -- 專案名稱
slug (string) -- 專案 slug
web (string) -- 專案網站
workspace (string) -- Optional workspace UUID. Creating a project in a workspace requires Add projects to workspace permission for that workspace. When omitted, Weblate can use the only eligible workspace. Creating a project without an eligible workspace requires the site-wide Add new projects permission. See 專案建立和移動.
access_control (integer) -- 存取控制
public_sharing (boolean) -- 公開分享
use_shared_tm (boolean) -- 使用共享的翻譯記憶
contribute_shared_tm (boolean) -- 貢獻至共享翻譯記憶
use_workspace_tm (boolean) -- 使用工作空間翻譯記憶
contribute_workspace_tm (boolean) -- 貢獻至工作空間翻譯記憶
autoclean_tm (boolean) -- 自動清理翻譯記憶
Omit
access_controlto use the configured default. Explicit non-default access control requires a superuser unless a billing plan determines the value. On Hosted Weblate, Custom access control is unavailable and each translation-memory contribution setting is forced to match its corresponding usage setting.
- GET /api/projects/(string: project)/¶
Returns information about the project.
- 參數:
project (string) -- Project URL slug
- Request JSON Object:
name (string) -- project name
slug (string) -- project slug
web (string) -- project website
components_list_url (string) -- URL to components list; see
GET /api/projects/(string:project)/components/repository_url (string) -- URL to repository status; see
GET /api/projects/(string:project)/repository/changes_list_url (string) -- URL to changes list; see
GET /api/projects/(string:project)/changes/reports_url (string) -- URL to list or generate scoped reports; see
GET /api/projects/(string:project)/reports/translation_review (boolean) -- 啟用檢閱
source_review (boolean) -- 啟用來源檢閱
enable_hooks (boolean) -- 啟用掛勾
workspace (string) -- workspace UUID, or
nullwhen the project is not assigned to a workspaceinstructions (string) -- 翻譯說明
language_aliases (string) -- 語言別名
license (string) -- 翻譯授權條款
enforced_checks (array) -- Locally configured enforced checks.
inherit_enforced_checks (boolean) -- Whether enforced checks are inherited from the workspace.
effective_enforced_checks (array) -- Enforced checks currently applied to the project (read-only).
access_control (integer) -- 存取控制
public_sharing (boolean) -- 公開分享
use_shared_tm (boolean) -- 使用共享的翻譯記憶
contribute_shared_tm (boolean) -- 貢獻至共享翻譯記憶
use_workspace_tm (boolean) -- 使用工作空間翻譯記憶
contribute_workspace_tm (boolean) -- 貢獻至工作空間翻譯記憶
autoclean_tm (boolean) -- 自動清理翻譯記憶
announcements_url (string) -- URL to announcements; see
GET /api/projects/(string:project)/announcements/
Example JSON data:
{ "name": "Hello", "slug": "hello", "url": "http://example.com/api/projects/hello/", "web": "https://weblate.org/", "web_url": "http://example.com/projects/hello/" }
- GET /api/projects/(string: project)/languages/(string: language)/workflow/¶
Return project-language workflow settings. When no project override exists, return inherited site-wide workflow settings, or defaults when none exist, without creating an override. Reviews remain disabled when both project review settings are disabled. The language is identified by its code. Access to the project is required.
- Request JSON Object:
language (string) -- Language code (read-only)
source_language (string) -- Custom source language code, or null for the component source; see 自訂來源語言
translation_review (boolean) -- Enable translation review
enable_suggestions (boolean) -- 啟用建議
restrict_direct_editing (boolean) -- Require suggestions instead of direct editing
suggestion_voting (boolean) -- Enable voting on suggestions
suggestion_autoaccept (integer) -- Number of votes required to accept suggestions, or 0 to disable
- PATCH /api/projects/(string: project)/languages/(string: language)/workflow/¶
Create or update a project-language workflow override. Requires permission to edit the project. Accepts the writable fields returned by
GET /api/projects/(string:project)/languages/(string:language)/workflow/. Omitted fields retain their values, including inherited workflow settings when creating an override. Enabling reviews requires source or translation reviews to be enabled on the project. Setsource_languageto null to use the component source. Source languages must exist in the project and must not form a dependency cycle. Changes reconcile affected units before the request completes.
- DELETE /api/projects/(string: project)/languages/(string: language)/workflow/¶
Remove the project-language workflow override, restoring inherited settings. Requires permission to edit the project. Returns HTTP 204, including when no override exists.
All three methods return HTTP 409 if legacy data contains multiple workflow overrides for the same project and language. Resolve the duplicate settings before using this endpoint; the API does not choose or delete them implicitly.
- PATCH /api/projects/(string: project)/¶
在 4.3 版被加入.
Edit a project by a PATCH request.
The
projectvalue is the project slug. To avoid using a wrong identifier, use the projecturlreturned byGET /api/projects/orGET /api/projects/(string:project)/.The request body accepts project fields such as
instructions,license,access_control, and translation-memory settings.Example JSON data:
{ "instructions": "Translate consistently.", "license": "MIT", "use_shared_tm": true, "access_control": 100 }
Changing
access_controlorpublic_sharingrequires permission to manage project access. Making a project publicly accessible can require licenses on its components whenLICENSE_REQUIREDis enabled. On Hosted Weblate, Custom access control is unavailable and each translation-memory contribution setting is forced to match its corresponding usage setting.Changing
workspacemoves the project. Moving a project requires permission to edit the project and the Edit workspace settings permission for the source and target workspace. The target workspace also requires the Add projects to workspace permission. Moving a project out of a workspace also requires the site-wide Add new projects permission. See 專案建立和移動.- 參數:
project (string) -- Project URL slug
instructions (string) -- 翻譯說明
license (string) -- 翻譯授權條款
access_control (integer) -- 存取控制
public_sharing (boolean) -- 公開分享
use_shared_tm (boolean) -- 使用共享的翻譯記憶
contribute_shared_tm (boolean) -- 貢獻至共享翻譯記憶
use_workspace_tm (boolean) -- 使用工作空間翻譯記憶
contribute_workspace_tm (boolean) -- 貢獻至工作空間翻譯記憶
autoclean_tm (boolean) -- 自動清理翻譯記憶
workspace (string) -- Optional workspace UUID, or
nullto move the project out of a workspace
- PUT /api/projects/(string: project)/¶
在 4.3 版被加入.
Edit a project by a PUT request.
Changing
workspacefollows the same permission checks asPATCH /api/projects/(string:project)/.- 參數:
project (string) -- Project URL slug
instructions (string) -- 翻譯說明
license (string) -- 翻譯授權條款
access_control (integer) -- 存取控制
public_sharing (boolean) -- 公開分享
use_shared_tm (boolean) -- 使用共享的翻譯記憶
contribute_shared_tm (boolean) -- 貢獻至共享翻譯記憶
use_workspace_tm (boolean) -- 使用工作空間翻譯記憶
contribute_workspace_tm (boolean) -- 貢獻至工作空間翻譯記憶
autoclean_tm (boolean) -- 自動清理翻譯記憶
- DELETE /api/projects/(string: project)/¶
Deletes a project.
- 參數:
project (string) -- Project URL slug
- GET /api/projects/(string: project)/changes/¶
Returns a list of project changes. This is essentially a project scoped
GET /api/changes/accepting same params.- 參數:
project (string) -- Project URL slug
- Request JSON Object:
results (array) -- array of component objects; see
GET /api/changes/(int:id)/
- GET /api/projects/(string: project)/file/¶
在 5.5 版被加入.
Downloads all available translations associated with the project as an archive file using the requested format and language. An unfiltered archive requires project-wide download permission. When
language_codeis specified, download permission is evaluated for that language.- 參數:
project (string) -- Project URL slug
- Query Parameters:
format (string) -- The archive format to use; If not specified, defaults to
zip; Supported formats:zipandzip:CONVERSIONwhereCONVERSIONis one of converters listed at 下載翻譯.language_code (string) -- The language code to download; If not specified, all languages are included.
- GET /api/projects/(string: project)/repository/¶
Returns information about the VCS repository status. This endpoint contains only an overall summary for all repositories for the project. To get more detailed status use
GET /api/components/(string:project)/(string:component)/repository/.Repository status includes repositories where the user has a VCS permission on the component owning that repository. Repositories whose owners do not grant this permission are omitted and reported separately.
- 參數:
project (string) -- Project URL slug
- Request JSON Object:
needs_commit (boolean) -- whether there are any pending changes to commit
needs_merge (boolean) -- whether there are any upstream changes to merge
needs_push (boolean) -- whether there are any local changes to push
included_components (array) -- full paths of project components included in the status
skipped_components (array) -- full paths of project components omitted from the status
permission_blockers (array) -- full paths of components preventing access to omitted repositories
Example JSON data:
{ "included_components": ["hello/app"], "needs_commit": true, "needs_merge": false, "needs_push": true, "permission_blockers": ["shared/glossary"], "skipped_components": ["hello/glossary"] }
- POST /api/projects/(string: project)/repository/¶
Performs given operation on the VCS repository.
Repository operations process repositories where the user has the requested VCS permission on the component owning that repository. Repositories whose owners do not grant this permission are skipped. The request is denied when no repository is eligible for the operation.
- 參數:
project (string) -- Project URL slug
- Response JSON Object:
operation (string) -- Operation to perform: one of
push,pull,commit,reset,cleanup,file-sync,file-scanbackground (boolean) -- Schedule the operation as a background task instead of waiting for it to finish. Defaults to
false.
- Request JSON Object:
result (boolean) -- result of a synchronous operation
included_components (array) -- full paths of project components included in the operation
skipped_components (array) -- full paths of project components omitted from the operation
permission_blockers (array) -- full paths of components preventing access to omitted repositories
detail (string) -- Status of a background operation
task_url (string) -- URL for tracking a background operation; see
GET /api/tasks/(str:uuid)/
With
backgroundset totrue, the endpoint returns202 Accepted. Repeating an identical queued operation returns the existing task URL. A conflicting operation returns423 Lockedand the active task URL when available. Eligible project repositories are processed sequentially in one task.CURL 範例:
curl \ -d operation=pull \ -H "Authorization: Token TOKEN" \ http://example.com/api/projects/hello/repository/
JSON 請求範例:
POST /api/projects/hello/repository/ HTTP/1.1 Host: example.com Accept: application/json Content-Type: application/json Authorization: Token TOKEN Content-Length: 20 {"operation":"pull"}
JSON response example:
HTTP/1.0 200 OK Date: Tue, 12 Apr 2016 09:32:50 GMT Server: WSGIServer/0.1 Python/2.7.11+ Vary: Accept, Accept-Language, Cookie X-Frame-Options: SAMEORIGIN Content-Type: application/json Content-Language: en Allow: GET, POST, HEAD, OPTIONS { "included_components": ["hello/app"], "permission_blockers": ["shared/glossary"], "result": true, "skipped_components": ["hello/glossary"] }
Background JSON request example:
POST /api/projects/hello/repository/ HTTP/1.1 Host: example.com Accept: application/json Content-Type: application/json Authorization: Token TOKEN {"operation":"pull","background":true}
Background JSON response example:
HTTP/1.0 202 Accepted Content-Type: application/json { "detail": "Repository operation has been queued.", "included_components": ["hello/app"], "permission_blockers": ["shared/glossary"], "skipped_components": ["hello/glossary"], "task_url": "https://example.com/api/tasks/01234567-89ab-cdef-0123-456789abcdef/" }
- GET /api/projects/(string: project)/components/¶
Returns a list of translation components in the given project.
- 參數:
project (string) -- Project URL slug
- Request JSON Object:
results (array) -- array of component objects; see
GET /api/components/(string:project)/(string:component)/
- POST /api/projects/(string: project)/components/¶
在 4.3 版的變更: The
zipfileanddocfileparameters are now accepted for VCS-less components, see 本機檔案.在 4.6 版的變更: The cloned repositories are now automatically shared within a project using Weblate 內部 URL. Use
disable_autoshareto turn off this.Creates translation components in the given project.
提示
Use Weblate 內部 URL when creating multiple components from a single VCS repository.
備註
Most of the component creation happens in the background. Check the
task_urlattribute of created component and follow the progress there.- 參數:
project (string) -- Project URL slug
- Form Parameters:
file zipfile -- ZIP file to upload into Weblate for translations initialization
file docfile -- Document to translate
string from_component -- Optional source component reference used to duplicate the new component. Accepts either a numeric component ID or a full Weblate component path. When provided, the new component inherits the source component configuration and translations into a new local repository. Repository fields such as
repo,vcs,branch,push, andpush_branchcan not be combined with this option.boolean disable_autoshare -- Disables automatic repository sharing via Weblate 內部 URL.
- Response JSON Object:
object -- Component parameters, see
GET /api/components/(string:project)/(string:component)/
- Request JSON Object:
result (object) -- Created component object; see
GET /api/components/(string:project)/(string:component)/
JSON can not be used when uploading the files using the
zipfileanddocfileparameters. The data has to be uploaded as multipart/form-data.CURL form request example:
curl \ --form docfile=@strings.html \ --form name=Weblate \ --form slug=weblate \ --form file_format=html \ --form new_lang=add \ -H "Authorization: Token TOKEN" \ http://example.com/api/projects/hello/components/
CURL JSON request example:
curl \ --data-binary '{ "branch": "main", "file_format": "po", "file_format_params": { "po_line_wrap": 65535, "po_no_location": true }, "filemask": "po/*.po", "name": "Weblate", "slug": "weblate", "repo": "https://github.com/WeblateOrg/hello.git", "template": "", "new_base": "po/hello.pot", "vcs": "git" }' \ -H "Content-Type: application/json" \ -H "Authorization: Token TOKEN" \ http://example.com/api/projects/hello/components/
JSON request to create a new component from Git:
POST /api/projects/hello/components/ HTTP/1.1 Host: example.com Accept: application/json Content-Type: application/json Authorization: Token TOKEN Content-Length: 20 { "branch": "main", "file_format": "po", "file_format_params": { "po_line_wrap": 65535, "po_no_location": true }, "filemask": "po/*.po", "name": "Weblate", "slug": "weblate", "repo": "https://github.com/WeblateOrg/hello.git", "template": "", "new_base": "po/hello.pot", "vcs": "git" }
JSON request to create a new component from another one:
POST /api/projects/hello/components/ HTTP/1.1 Host: example.com Accept: application/json Content-Type: application/json Authorization: Token TOKEN Content-Length: 20 { "from_component": "hello/weblate", "name": "Weblate", "slug": "weblate" }
JSON response example:
HTTP/1.0 200 OK Date: Tue, 12 Apr 2016 09:32:50 GMT Server: WSGIServer/0.1 Python/2.7.11+ Vary: Accept, Accept-Language, Cookie X-Frame-Options: SAMEORIGIN Content-Type: application/json Content-Language: en Allow: GET, POST, HEAD, OPTIONS { "branch": "main", "file_format": "po", "file_format_params": { "po_line_wrap": 65535, "po_no_location": true }, "filemask": "po/*.po", "git_export": "", "license": "", "license_url": "", "name": "Weblate", "slug": "weblate", "project": { "name": "Hello", "slug": "hello", "source_language": { "code": "en", "direction": "ltr", "population": 159034349015, "name": "English", "url": "http://example.com/api/languages/en/", "web_url": "http://example.com/languages/en/" }, "url": "http://example.com/api/projects/hello/", "web": "https://weblate.org/", "web_url": "http://example.com/projects/hello/" }, "repo": "https://github.com/WeblateOrg/hello.git", "template": "", "new_base": "", "url": "http://example.com/api/components/hello/weblate/", "vcs": "git", "web_url": "http://example.com/projects/hello/weblate/" }
- GET /api/projects/(string: project)/languages/¶
Returns paginated statistics for all languages within a project.
- 參數:
project (string) -- Project URL slug
- Request JSON Object:
results (array) -- array of translation statistics objects
language (string) -- language name
code (string) -- language code
total (int) -- total number of strings
translated (int) -- number of translated strings
translated_percent (float) -- percentage of translated strings
total_words (int) -- total number of words
translated_words (int) -- number of translated words
words_percent (float) -- percentage of translated words
- GET /api/projects/(string: project)/statistics/¶
Returns statistics for a project.
- 參數:
project (string) -- Project URL slug
也參考
Returned attributes are described in 統計資料.
- GET /api/projects/(string: project)/metrics/¶
在 2026.8 版被加入.
Returns translation metrics for the project components visible to the caller. Components are identified by their project-relative path and the result is grouped by component and language. When multiple components have the same project-relative path,
@and the component ID are appended to each colliding path.The OpenMetrics representation exposes
weblate_translation_infoandweblate_*gauges compatible with the project translation statistics. Strings containing suggestions useweblate_strings_with_suggestionsto distinguish them from the server-wideweblate_suggestionsobject count. The CSV representation contains one row for each component, language, and numeric metric.- 參數:
project (string) -- Project URL slug
- Query Parameters:
format (string) -- Response format; use
openmetricsorcsvfor monitoring and tabular output.
- GET /api/projects/(string: project)/categories/¶
在 5.0 版被加入: Returns categories for a project. See
GET /api/categories/(int:id)/for field definitions.- param project:
Project URL slug
- type project:
字串
- GET /api/projects/(string: project)/labels/¶
在 5.3 版被加入: Returns labels for a project.
- param project:
Project URL slug
- type project:
字串
- >json int id:
ID of the label
- >json string name:
name of the label
- >json string color:
color of the label
- POST /api/projects/(string: project)/labels/¶
在 5.3 版被加入: Creates a label for a project. The label color is required.
- param project:
Project URL slug
- type project:
字串
- <json string name:
name of the label
- <json string color:
color of the label
- DELETE /api/projects/(string: project)/labels/(int: label_id)/¶
在 5.14 版被加入: Deletes a label from a project.
- param project:
Project URL slug
- type project:
字串
- param label_id:
ID of the label to delete
- type label_id:
整數
- GET /api/projects/(string: project)/reports/¶
Lists accessible reports generated directly for a project.
- POST /api/projects/(string: project)/reports/¶
Schedules a report using the project as its scope. The request and response match
POST /api/reports/; scope fields must be omitted.
- GET /api/projects/(string: project)/translation-services/¶
在 5.9 版被加入.
Returns a list of automatic suggestion installations configured directly on the project. Each entry has an
id,selector,engine, optionalslug,configuration,enabledstate, and scope fields. The configuration can contain credentials and is returned only to users who can edit the installation's scope.- 參數:
project (string) -- Project URL slug
- Request JSON Object:
installations (array) -- Project installations.
- POST /api/projects/(string: project)/translation-services/¶
在 5.9 版被加入.
Create an automatic suggestion installation for a project. Use
/api/translation-services/(int:id)/to update or remove one. The/api/translation-service-exclusions/endpoint manages inherited installations excluded by a workspace or project. An installation's service cannot be changed after creation; create another installation to use a different service. An exclusion's scope and target cannot be changed after creation; remove it and create another exclusion to select a different target.- 參數:
project (string) -- Project URL slug
- Form Parameters:
string engine -- Service name
string slug -- Optional installation slug
string configuration -- Service configuration in JSON
- GET /api/projects/(string: project)/machinery_settings/¶
在 2026.11 版被移除: Use
GET /api/projects/(string:project)/translation-services/instead.
- POST /api/projects/(string: project)/machinery_settings/¶
在 2026.11 版被移除: Use
POST /api/projects/(string:project)/translation-services/instead.
- GET /api/projects/(string: project)/languages/(string: language_code)/file/¶
在 5.15.1 版的變更: Added ability to download ZIP file of all components translations in a project for 1 specific language.
Download a ZIP file of all translation files for a specified
language_codeacross all components for a givenprojectrather than downloading individual translated files and manually zipping them, with the archive named {project-slug}-{language-code}.zip and organized by component paths (e.g., component-slug/po/lang.po). Download permission is evaluated for the requested language.- 參數:
project (string) -- Project URL slug
language_code (string) -- 語言代碼
- Query Parameters:
filter (string) -- Optional case-insensitive substring to filter components by slug (e.g.,
?filter=corewill match components with 'core' anywhere in their slug); only components whose slugs contain the substring will be included in the download.format (string) -- The archive format to use; If not specified, defaults to
zip; Supported formats:zipandzip:CONVERSIONwhereCONVERSIONis one of converters listed at 下載翻譯.
備註
Possible responses:
200 OKwith the ZIP file of translations for the specified language across all components in the project. If no components have translations for the specified language, an empty ZIP file will be returned.403 Forbiddenif the user does not have download permission for the requested language.404 Not Foundif the project slug or language code does not exist.
- GET /api/projects/(string: project)/languages/(string: language_code)/announcements/¶
在 2026.6 版被加入: Returns announcements for a specified
language_codein a project.- param project:
Project URL slug
- type project:
字串
- param language_code:
語言代碼
- type language_code:
字串
- >json int id:
ID of the announcement
- >json string message:
announcement text
- >json string severity:
color of the message, one of
info(light blue),warning(yellow),danger(red),success(green)- >json date expiry:
hide after this date, ISO 8601 extended format date (optional)
- >json bool notify:
send notification to subscribed users? (optional)
- POST /api/projects/(string: project)/languages/(string: language_code)/announcements/¶
在 2026.6 版被加入: Creates an announcement for a specified
language_codein a project.- param project:
Project URL slug
- type project:
字串
- param language_code:
語言代碼
- type language_code:
字串
- <json string message:
announcement text
- <json string severity:
color of the message, one of
info(light blue),warning(yellow),danger(red),success(green)- <json date expiry:
hide after this date, ISO 8601 extended format date (optional)
- <json bool notify:
send notification to subscribed users? (optional)
- DELETE /api/projects/(string: project)/languages/(string: language_code)/announcements/(int: announcement_id)/¶
在 2026.6 版被加入: Deletes an announcement from a specified
language_codein a project.- param project:
Project URL slug
- type project:
字串
- param language_code:
語言代碼
- type language_code:
字串
- param announcement_id:
ID of the announcement to delete
- type announcement_id:
整數
- GET /api/projects/(string: project)/announcements/¶
在 5.17 版被加入: Returns announcements for a project.
- param project:
Project URL slug
- type project:
字串
- >json int id:
ID of the announcement
- >json string message:
announcement text
- >json string severity:
color of the message, one of
info(light blue),warning(yellow),danger(red),success(green)- >json date expiry:
hide after this date, ISO 8601 extended format date (optional)
- >json bool notify:
send notification to subscribed users? (optional)
- POST /api/projects/(string: project)/announcements/¶
在 5.17 版被加入: Creates an announcement for a project.
- param project:
Project URL slug
- type project:
字串
- <json string message:
announcement text
- <json string severity:
color of the message, one of
info(light blue),warning(yellow),danger(red),success(green)- <json date expiry:
hide after this date, ISO 8601 extended format date (optional)
- <json bool notify:
send notification to subscribed users? (optional)
- DELETE /api/projects/(string: project)/announcements/(int: announcement_id)/¶
在 5.17 版被加入: Deletes an announcement from a project.
- param project:
Project URL slug
- type project:
字串
- param announcement_id:
ID of the announcement to delete
- type announcement_id:
整數
- GET /api/projects/(string: project)/backups/¶
在 2026.7 版被加入: Returns a list of 專案層級備份 archives. Project backups contain all project components, including restricted components, and require Edit project settings.
- param project:
Project URL slug
- type project:
字串
- >json string name:
Backup file name, for example
1718803200.zip- >json string timestamp:
Backup creation time in ISO 8601 format
- >json int size:
Backup file size in bytes
- POST /api/projects/(string: project)/backups/¶
在 2026.7 版被加入: Schedules creation of a new 專案層級備份 archive. Once ready, the backup appears in
GET /api/projects/(string:project)/backups/.- param project:
Project URL slug
- type project:
字串
- >json string detail:
Result message
- >json string url:
URL to list backups
- GET /api/projects/(string: project)/backups/(string: backup)/¶
在 2026.7 版被加入: Downloads a 專案層級備份 archive containing all project components, including restricted components. This requires Edit project settings.
- param project:
Project URL slug
- type project:
字串
- param backup:
Backup file name, e.g.
1718803200.zip- type backup:
字串
組件¶
提示
- GET /api/components/¶
Returns a list of translation components.
也參考
Component object attributes are documented at
GET /api/components/(string:project)/(string:component)/.
- GET /api/components/(string: project)/(string: component)/¶
Returns information about the translation component.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
- Request JSON Object:
project (object) -- the translation project; see
GET /api/projects/(string:project)/name (string) -- 組件名稱
slug (string) -- 組件代稱
vcs (string) -- 版本控制系統
vcs_params (object) -- 版本控制參數
linked_component (string) -- component whose repository is linked via Weblate 內部 URL
repo (string) -- 原始碼儲存庫, this is the actual repository URL even when Weblate 內部 URL are used, use
linked_componentto detect this situationgit_export (string) -- 已匯出儲存庫 URL
branch (string) -- 儲存庫分支, this is the actual repository branch even when Weblate 內部 URL are used
push (string) -- 儲存庫推送 URL, this is the actual repository URL even when Weblate 內部 URL are used
push_branch (string) -- 推送分支, this is the actual repository branch even when Weblate 內部 URL are used
filemask (string) -- 檔案遮罩
template (string) -- 單語言基底語言檔案
edit_template (string) -- 編輯基底檔案
intermediate (string) -- 中間語言檔案
new_base (string) -- 新翻譯的範本
file_format (string) -- 檔案格式
file_format_params (object) -- 檔案格式參數
license (string) -- 翻譯授權條款
agreement (string) -- 貢獻者授權協議
new_lang (string) -- 加入新翻譯
language_code_style (string) -- 語言代碼類型
source_language (object) -- source language object; see
GET /api/languages/(string:language)/check_flags (string) -- 翻譯旗標
priority (string) -- 優先度
enforced_checks (array) -- Locally configured enforced checks.
inherit_enforced_checks (boolean) -- Whether enforced checks are inherited from the category, project, or workspace.
effective_enforced_checks (array) -- Enforced checks currently applied to the component (read-only).
restricted (string) -- 受限制的存取
repoweb (string) -- 儲存庫瀏覽器
repoweb_translations (string) -- 翻譯檔案的儲存庫瀏覽器
report_source_bugs (string) -- 來源字串漏洞報告位址
merge_style (string) -- 合併類型
commit_message (string) -- 提交、新增、刪除、合併、附加元件與合併請求訊息
add_message (string) -- 提交、新增、刪除、合併、附加元件與合併請求訊息
delete_message (string) -- 提交、新增、刪除、合併、附加元件與合併請求訊息
merge_message (string) -- 提交、新增、刪除、合併、附加元件與合併請求訊息
addon_message (string) -- 提交、新增、刪除、合併、附加元件與合併請求訊息
pull_message (string) -- 提交、新增、刪除、合併、附加元件與合併請求訊息
allow_translation_propagation (string) -- 允許翻譯重用
hide_glossary_matches (boolean) -- 不要顯示詞彙表符合專案
contribute_project_tm (boolean) -- 貢獻至專案翻譯記憶
enable_suggestions (string) -- 啟用建議
suggestion_voting (string) -- 建議投票
suggestion_autoaccept (string) -- 自動接受建議
push_on_commit (boolean) -- 提交時一併推送; linked repositories expose the effective value from the linked component
push_on_update (boolean) -- Push on update; linked repositories expose the effective value from the linked component
locked (bool) -- Whether component is locked, this field is read-only; see
GET /api/components/(string:project)/(string:component)/lock/commit_pending_age (integer) -- 變更後提交的經過時間; linked repositories expose the effective value from the linked component
auto_lock_error (boolean) -- 有錯誤時鎖定; linked repositories expose the effective value from the linked component
language_regex (string) -- 語言篩選
variant_regex (string) -- 變體的正規表達式
is_glossary (bool) -- 當作詞彙表
glossary_color (string) -- 詞彙表色彩
repository_url (string) -- URL to repository status; see
GET /api/components/(string:project)/(string:component)/repository/translations_url (string) -- URL to translations list; see
GET /api/components/(string:project)/(string:component)/translations/lock_url (string) -- URL to lock status; see
GET /api/components/(string:project)/(string:component)/lock/changes_list_url (string) -- URL to changes list; see
GET /api/components/(string:project)/(string:component)/changes/task_url (string) -- URL to a background task (if any); see
GET /api/tasks/(str:uuid)/reports_url (string) -- URL to list or generate scoped reports; see
GET /api/components/(string:project)/(string:component)/reports/announcements_url (string) -- URL to announcements; see
GET /api/components/(string:project)/(string:component)/announcements/
Repository fields, including
linked_component, are returned only with the View upstream repository location permission.Example JSON data:
{ "branch": "main", "file_format": "po", "file_format_params": { "po_line_wrap": 65535, "po_no_location": true }, "filemask": "po/*.po", "git_export": "", "license": "", "license_url": "", "name": "Weblate", "slug": "weblate", "project": { "name": "Hello", "slug": "hello", "source_language": { "code": "en", "direction": "ltr", "population": 159034349015, "name": "English", "url": "http://example.com/api/languages/en/", "web_url": "http://example.com/languages/en/" }, "url": "http://example.com/api/projects/hello/", "web": "https://weblate.org/", "web_url": "http://example.com/projects/hello/" }, "source_language": { "code": "en", "direction": "ltr", "population": 159034349015, "name": "English", "url": "http://example.com/api/languages/en/", "web_url": "http://example.com/languages/en/" }, "repo": "https://github.com/WeblateOrg/hello.git", "template": "", "new_base": "", "url": "http://example.com/api/components/hello/weblate/", "vcs": "git", "web_url": "http://example.com/projects/hello/weblate/" }
- PATCH /api/components/(string: project)/(string: component)/¶
Edit a component by a PATCH request.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
source_language (string) -- Project source language code (optional)
- Response JSON Object:
name (string) -- name of component
slug (string) -- slug of component
repo (string) -- VCS repository URL
hide_glossary_matches (boolean) -- 不要顯示詞彙表符合專案
contribute_project_tm (boolean) -- 貢獻至專案翻譯記憶
Linking to another Weblate component using an internal URL requires permission to edit the referenced component. Changing 受限制的存取 follows the same direct component-access restrictions as the web interface.
CURL 範例:
curl \ --data-binary '{"name": "new name"}' \ -H "Content-Type: application/json" \ -H "Authorization: Token TOKEN" \ PATCH http://example.com/api/projects/hello/components/
JSON 請求範例:
PATCH /api/projects/hello/components/ HTTP/1.1 Host: example.com Accept: application/json Content-Type: application/json Authorization: Token TOKEN Content-Length: 20 { "name": "new name" }
JSON response example:
HTTP/1.0 200 OK Date: Tue, 12 Apr 2016 09:32:50 GMT Server: WSGIServer/0.1 Python/2.7.11+ Vary: Accept, Accept-Language, Cookie X-Frame-Options: SAMEORIGIN Content-Type: application/json Content-Language: en Allow: GET, POST, HEAD, OPTIONS { "branch": "main", "file_format": "po", "file_format_params": { "po_line_wrap": 65535, "po_no_location": true }, "filemask": "po/*.po", "git_export": "", "license": "", "license_url": "", "name": "new name", "slug": "weblate", "project": { "name": "Hello", "slug": "hello", "source_language": { "code": "en", "direction": "ltr", "population": 159034349015, "name": "English", "url": "http://example.com/api/languages/en/", "web_url": "http://example.com/languages/en/" }, "url": "http://example.com/api/projects/hello/", "web": "https://weblate.org/", "web_url": "http://example.com/projects/hello/" }, "repo": "https://github.com/WeblateOrg/hello.git", "template": "", "new_base": "", "url": "http://example.com/api/components/hello/weblate/", "vcs": "git", "web_url": "http://example.com/projects/hello/weblate/" }
- PUT /api/components/(string: project)/(string: component)/¶
Edit a component by a PUT request.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
- Response JSON Object:
branch (string) -- VCS repository branch
file_format (string) -- file format of translations
file_format_params (object) -- parameters related to the file
filemask (string) -- mask of translation files in the repository
name (string) -- name of component
slug (string) -- slug of component
repo (string) -- VCS repository URL
template (string) -- base file for monolingual translations
new_base (string) -- base file for adding new translations
vcs (string) -- version control system
vcs_params (object) -- 版本控制參數
hide_glossary_matches (boolean) -- 不要顯示詞彙表符合專案
contribute_project_tm (boolean) -- 貢獻至專案翻譯記憶
- DELETE /api/components/(string: project)/(string: component)/¶
Deletes a component.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
- GET /api/components/(string: project)/(string: component)/changes/¶
Returns a list of component changes. This is essentially a component scoped
GET /api/changes/accepting same params.- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
- Request JSON Object:
results (array) -- array of component objects; see
GET /api/changes/(int:id)/
- GET /api/components/(string: project)/(string: component)/file/¶
在 4.9 版被加入.
Downloads all available translations associated with the component as an archive file using the requested format.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
- Query Parameters:
format (string) -- The archive format to use; If not specified, defaults to
zip; Supported formats:zipandzip:CONVERSIONwhereCONVERSIONis one of converters listed at 下載翻譯.
- GET /api/components/(string: project)/(string: component)/screenshots/¶
Returns a list of component screenshots.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
- Request JSON Object:
results (array) -- array of component screenshots; see
GET /api/screenshots/(int:id)/
- GET /api/components/(string: project)/(string: component)/lock/¶
Returns component lock status.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
- Request JSON Object:
locked (boolean) -- whether component is locked for updates
Example JSON data:
{ "locked": false }
- POST /api/components/(string: project)/(string: component)/lock/¶
Sets component lock status.
Response is same as
GET /api/components/(string:project)/(string:component)/lock/.- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
- Response JSON Object:
lock -- Boolean whether to lock or not.
CURL 範例:
curl \ -d lock=true \ -H "Authorization: Token TOKEN" \ http://example.com/api/components/hello/weblate/repository/
JSON 請求範例:
POST /api/components/hello/weblate/repository/ HTTP/1.1 Host: example.com Accept: application/json Content-Type: application/json Authorization: Token TOKEN Content-Length: 20 {"lock": true}
JSON response example:
HTTP/1.0 200 OK Date: Tue, 12 Apr 2016 09:32:50 GMT Server: WSGIServer/0.1 Python/2.7.11+ Vary: Accept, Accept-Language, Cookie X-Frame-Options: SAMEORIGIN Content-Type: application/json Content-Language: en Allow: GET, POST, HEAD, OPTIONS {"locked":true}
- GET /api/components/(string: project)/(string: component)/repository/¶
Returns information about the VCS repository status.
The response is same as for
GET /api/projects/(string:project)/repository/.Repository status requires component-wide permission on the component that owns the repository, including when accessing it through a linked component in another project.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
- Request JSON Object:
needs_commit (boolean) -- whether there are any pending changes to commit
needs_merge (boolean) -- whether there are any upstream changes to merge
needs_push (boolean) -- whether there are any local changes to push
remote_commit (string) -- Remote commit information
status (string) -- VCS repository status as reported by VCS
merge_failure -- Text describing merge failure or null if there is none
- POST /api/components/(string: project)/(string: component)/repository/¶
Performs the given operation on a VCS repository.
See
POST /api/projects/(string:project)/repository/for documentation.Repository operations require component-wide permission on the component that owns the repository, including when accessing it through a linked component in another project.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
- Response JSON Object:
operation (string) -- Operation to perform: one of
push,pull,commit,reset,cleanup
- Request JSON Object:
result (boolean) -- result of the operation
CURL 範例:
curl \ -d operation=pull \ -H "Authorization: Token TOKEN" \ http://example.com/api/components/hello/weblate/repository/
JSON 請求範例:
POST /api/components/hello/weblate/repository/ HTTP/1.1 Host: example.com Accept: application/json Content-Type: application/json Authorization: Token TOKEN Content-Length: 20 {"operation":"pull"}
JSON response example:
HTTP/1.0 200 OK Date: Tue, 12 Apr 2016 09:32:50 GMT Server: WSGIServer/0.1 Python/2.7.11+ Vary: Accept, Accept-Language, Cookie X-Frame-Options: SAMEORIGIN Content-Type: application/json Content-Language: en Allow: GET, POST, HEAD, OPTIONS {"result":true}
- GET /api/components/(string: project)/(string: component)/monolingual_base/¶
Downloads base file for monolingual translations.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
- GET /api/components/(string: project)/(string: component)/new_template/¶
Downloads template file for new translations.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
- GET /api/components/(string: project)/(string: component)/translations/¶
Returns a list of translation objects in the given component.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
- Request JSON Object:
results (array) -- array of translation objects; see
GET /api/translations/(string:project)/(string:component)/(string:language)/
- POST /api/components/(string: project)/(string: component)/translations/¶
Creates new translation in the given component.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
- Response JSON Object:
language_code (string) -- translation language code; see
GET /api/languages/(string:language)/from_component (array) -- optional ordered list of source component references used for automatic translation. Accepts numeric component IDs or full Weblate component paths. For form submissions this field can be provided multiple times.
- Request JSON Object:
result (object) -- new translation object created
CURL 範例:
curl \ -d language_code=cs \ -H "Authorization: Token TOKEN" \ http://example.com/api/projects/hello/components/
JSON 請求範例:
POST /api/projects/hello/components/ HTTP/1.1 Host: example.com Accept: application/json Content-Type: application/json Authorization: Token TOKEN Content-Length: 20 { "language_code": "cs", "from_component": ["hello/weblate", 123] }
JSON response example:
HTTP/1.0 200 OK Date: Tue, 12 Apr 2016 09:32:50 GMT Server: WSGIServer/0.1 Python/2.7.11+ Vary: Accept, Accept-Language, Cookie X-Frame-Options: SAMEORIGIN Content-Type: application/json Content-Language: en Allow: GET, POST, HEAD, OPTIONS { "failing_checks": 0, "failing_checks_percent": 0, "failing_checks_words": 0, "filename": "po/cs.po", "fuzzy": 0, "fuzzy_percent": 0.0, "fuzzy_words": 0, "have_comment": 0, "have_suggestion": 0, "is_template": false, "is_source": false, "language": { "code": "cs", "direction": "ltr", "population": 1303174280 "name": "Czech", "url": "http://example.com/api/languages/cs/", "web_url": "http://example.com/languages/cs/" }, "language_code": "cs", "id": 125, "last_author": null, "last_change": null, "share_url": "http://example.com/engage/hello/cs/", "total": 4, "total_words": 15, "translate_url": "http://example.com/translate/hello/weblate/cs/", "translated": 0, "translated_percent": 0.0, "translated_words": 0, "url": "http://example.com/api/translations/hello/weblate/cs/", "web_url": "http://example.com/projects/hello/weblate/cs/" }
- GET /api/components/(string: project)/(string: component)/statistics/¶
Returns paginated statistics for all translations within component.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
也參考
Returned attributes are described in 統計資料.
- GET /api/components/(string: project)/(string: component)/links/¶
Returns projects linked with a component.
Component managers see every linked project. Other callers see only linked projects they can access.
在 4.5 版被加入.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
- Request JSON Object:
projects (array) -- associated projects; see
GET /api/projects/(string:project)/
- POST /api/components/(string: project)/(string: component)/links/¶
Associate project with a component.
This requires permission to edit the component and the target project.
在 4.5 版被加入.
在 5.17 版的變更.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
- Form Parameters:
string project_slug -- 專案 slug
int category_id -- Category ID in the target project (optional). The category must belong to the specified project.
- DELETE /api/components/(string: project)/(string: component)/links/(string: project_slug)/¶
Remove association of a project with a component.
在 4.5 版被加入.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
project_slug (string) -- Slug of the project to remove
- GET /api/components/(string: project)/(string: component)/reports/¶
Lists accessible reports generated directly for a component.
- POST /api/components/(string: project)/(string: component)/reports/¶
Schedules a report using the component as its scope. The request and response match
POST /api/reports/; scope fields must be omitted.
- GET /api/components/(string: project)/(string: component)/announcements/¶
在 5.17 版被加入: Returns announcements for a component.
- param project:
Project URL slug
- type project:
字串
- param component:
Component URL slug
- type component:
字串
- >json int id:
ID of the announcement
- >json string message:
announcement text
- >json string severity:
color of the message, one of
info(light blue),warning(yellow),danger(red),success(green)- >json date expiry:
hide after this date, ISO 8601 extended format date (optional)
- >json bool notify:
send notification to subscribed users? (optional)
- POST /api/components/(string: project)/(string: component)/announcements/¶
在 5.17 版被加入: Creates an announcement for a component.
- param project:
Project URL slug
- type project:
字串
- param component:
Component URL slug
- type component:
字串
- <json string message:
announcement text
- <json string severity:
color of the message, one of
info(light blue),warning(yellow),danger(red),success(green)- <json date expiry:
hide after this date, ISO 8601 extended format date (optional)
- <json bool notify:
send notification to subscribed users? (optional)
- DELETE /api/components/(string: project)/(string: component)/announcements/(int: announcement_id)/¶
在 5.17 版被加入: Deletes an announcement from a component.
- param project:
Project URL slug
- type project:
字串
- param component:
Component URL slug
- type component:
字串
- param announcement_id:
ID of the announcement to delete
- type announcement_id:
整數
翻譯¶
- GET /api/translations/¶
Returns a list of translations.
也參考
Translation object attributes are documented at
GET /api/translations/(string:project)/(string:component)/(string:language)/.
- GET /api/translations/(string: project)/(string: component)/(string: language)/¶
Returns information about the translation.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
language (string) -- 翻譯語言代碼
- Request JSON Object:
component (object) -- component object; see
GET /api/components/(string:project)/(string:component)/failing_checks (int) -- number of strings failing checks
failing_checks_percent (float) -- percentage of strings failing checks
failing_checks_words (int) -- number of words with failing checks
filename (string) -- translation filename
fuzzy (int) -- number of fuzzy (marked for edit) strings
fuzzy_percent (float) -- percentage of fuzzy (marked for edit) strings
fuzzy_words (int) -- number of words in fuzzy (marked for edit) strings
have_comment (int) -- number of strings with comment
have_suggestion (int) -- number of strings with suggestion
is_template (boolean) -- whether the translation has a monolingual base
language (object) -- source language object; see
GET /api/languages/(string:language)/language_code (string) -- language code used in the repository; this can be different from language code in the language object
last_author (string) -- name of last author
last_change (timestamp) -- last change timestamp
revision (string) -- revision hash for the file
share_url (string) -- URL for sharing leading to engagement page
total (int) -- total number of strings
total_words (int) -- total number of words
translate_url (string) -- URL for translating
translated (int) -- number of translated strings
translated_percent (float) -- percentage of translated strings
translated_words (int) -- number of translated words
repository_url (string) -- URL to repository status; see
GET /api/translations/(string:project)/(string:component)/(string:language)/repository/file_url (string) -- URL to file object; see
GET /api/translations/(string:project)/(string:component)/(string:language)/file/changes_list_url (string) -- URL to changes list; see
GET /api/translations/(string:project)/(string:component)/(string:language)/changes/units_list_url (string) -- URL to strings list; see
GET /api/translations/(string:project)/(string:component)/(string:language)/units/announcements_url (string) -- URL to announcements; see
GET /api/translations/(string:project)/(string:component)/(string:language)/announcements/
Example JSON data:
{ "component": { "branch": "main", "file_format": "po", "file_format_params": { "po_line_wrap": 65535, "po_no_location": true }, "filemask": "po/*.po", "git_export": "", "license": "", "license_url": "", "name": "Weblate", "new_base": "", "project": { "name": "Hello", "slug": "hello", "source_language": { "code": "en", "direction": "ltr", "population": 159034349015, "name": "English", "url": "http://example.com/api/languages/en/", "web_url": "http://example.com/languages/en/" }, "url": "http://example.com/api/projects/hello/", "web": "https://weblate.org/", "web_url": "http://example.com/projects/hello/" }, "repo": "https://github.com/WeblateOrg/hello.git", "slug": "weblate", "template": "", "url": "http://example.com/api/components/hello/weblate/", "vcs": "git", "web_url": "http://example.com/projects/hello/weblate/" }, "failing_checks": 3, "failing_checks_percent": 75.0, "failing_checks_words": 11, "filename": "po/cs.po", "fuzzy": 0, "fuzzy_percent": 0.0, "fuzzy_words": 0, "have_comment": 0, "have_suggestion": 0, "is_template": false, "language": { "code": "cs", "direction": "ltr", "population": 1303174280 "name": "Czech", "url": "http://example.com/api/languages/cs/", "web_url": "http://example.com/languages/cs/" }, "language_code": "cs", "last_author": "Weblate Admin", "last_change": "2016-03-07T10:20:05.499", "revision": "7ddfafe6daaf57fc8654cc852ea6be212b015792", "share_url": "http://example.com/engage/hello/cs/", "total": 4, "total_words": 15, "translate_url": "http://example.com/translate/hello/weblate/cs/", "translated": 4, "translated_percent": 100.0, "translated_words": 15, "url": "http://example.com/api/translations/hello/weblate/cs/", "web_url": "http://example.com/projects/hello/weblate/cs/" }
- DELETE /api/translations/(string: project)/(string: component)/(string: language)/¶
Deletes a translation.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
language (string) -- 翻譯語言代碼
- GET /api/translations/(string: project)/(string: component)/(string: language)/changes/¶
Returns a list of translation changes. This is essentially a translations-scoped
GET /api/changes/accepting the same parameters.- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
language (string) -- 翻譯語言代碼
- Request JSON Object:
results (array) -- array of component objects; see
GET /api/changes/(int:id)/
- GET /api/translations/(string: project)/(string: component)/(string: language)/units/¶
Returns a list of translation units.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
language (string) -- 翻譯語言代碼
q (string) -- Search query string 搜尋 (optional)
- Request JSON Object:
results (array) -- array of component objects; see
GET /api/units/(int:id)/
- POST /api/translations/(string: project)/(string: component)/(string: language)/units/¶
Add new unit.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
language (string) -- 翻譯語言代碼
- Response JSON Object:
key (string) -- Monolingual translations: Key of translation unit
value (array) -- Monolingual translations: Source strings (use single string if not creating plural)
context (string) -- Bilingual translations: Context of a translation unit
source (array) -- Bilingual translations: Source strings (use single string if not creating plural)
target (array) -- Bilingual translations: Target strings (use single string if not creating plural)
state (int) -- String state; see
GET /api/units/(int:id)/
- Request JSON Object:
unit (object) -- newly created unit; see
GET /api/units/(int:id)/
Creating a unit in the approved state requires permission to review strings.
- POST /api/translations/(string: project)/(string: component)/(string: language)/autotranslate/¶
在 5.13 版的變更: The
filter_typeparameter is no longer supported and filtering is done by theqparameter.在 2026.10 版的變更: Added the
backgroundparameter.Trigger automatic translation.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
language (string) -- 翻譯語言代碼
- Response JSON Object:
mode (string) -- Automatic translation mode; one of
suggest,translate,fuzzy,approvedq (string) -- Automatic translation search string, see 搜尋字串.
auto_source (string) -- Automatic translation source -
mtorotherscomponent (string) -- Component ID (always accepted); when the project has 30 or more eligible source components, a component slug or
project/componentpath is also accepted; leave blank to use all components in the projectengines (array) -- Machine translation engines to use when
auto_sourceismtthreshold (int) -- Score threshold for machine translation (1–100)
background (boolean) -- Schedule automatic translation as a background task instead of waiting for it to finish. Defaults to
false.
- Request JSON Object:
details (string) -- Human-readable summary of the translation result, or status of a background task
task_url (string) -- URL for tracking a background task; see
GET /api/tasks/(str:uuid)/
With
backgroundset totrue, the endpoint returns202 Acceptedonce the task is scheduled. Validation and permission errors are still reported immediately.
- GET /api/translations/(string: project)/(string: component)/(string: language)/file/¶
Download current translation file as it is stored in the VCS (without the
formatparameter) or converted to another format (see 下載翻譯).備註
This API endpoint uses different logic for output than rest of API as it operates on whole file rather than on data. Set of accepted
formatparameter differs and without such parameter you get translation file as stored in VCS.- Response Headers:
Last-Modified -- Timestamp of last change to this file.
- Request Headers:
If-Modified-Since -- Skips response if the file has not been modified since that time.
- Query Parameters:
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
language (string) -- 翻譯語言代碼
- POST /api/translations/(string: project)/(string: component)/(string: language)/file/¶
Upload new file with translations.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
language (string) -- 翻譯語言代碼
- Form Parameters:
boolean ignore_language -- Ignore a mismatch between the declared file language and the translation language (defaults to
false), see 語言檢查string conflicts -- How to deal with conflicts (
ignore,replace-translatedorreplace-approved), see 衝突處理file file -- Uploaded file or file content sent as a form field without a filename
string author_email -- Author e-mail
string author_name -- Author name
string method -- Upload method (
translate,approve,suggest,fuzzy,replace,source,add), see 匯入方法string fuzzy -- Fuzzy (marked for edit) strings processing (empty,
process,approve)
CURL 範例:
curl -X POST \ -F file=@strings.xml \ -H "Authorization: Token TOKEN" \ http://example.com/api/translations/hello/android/cs/file/
The
filefield can also be sent as form content without a filename, for example when piping data from another command:curl -X POST \ -F 'file=<strings.xml' \ -H "Authorization: Token TOKEN" \ http://example.com/api/translations/hello/android/cs/file/
The content is used as submitted, byte for byte, so any file encoding works.
- GET /api/translations/(string: project)/(string: component)/(string: language)/repository/¶
Returns information about the VCS repository status.
The response is same as for
GET /api/components/(string:project)/(string:component)/repository/.Repository status requires component-wide permission on the component that owns the repository, including when accessing it through a linked component in another project. A permission limited to the requested language is not sufficient.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
language (string) -- 翻譯語言代碼
- POST /api/translations/(string: project)/(string: component)/(string: language)/repository/¶
Performs given operation on the VCS repository.
See
POST /api/projects/(string:project)/repository/for documentation.Repository operations require component-wide permission on the component that owns the repository, including when accessing it through a linked component in another project. A permission limited to the requested language is not sufficient.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
language (string) -- 翻譯語言代碼
- Response JSON Object:
operation (string) -- Operation to perform: one of
push,pull,commit,reset,cleanup
- Request JSON Object:
result (boolean) -- result of the operation
- GET /api/translations/(string: project)/(string: component)/(string: language)/statistics/¶
Returns detailed translation statistics.
- 參數:
project (string) -- Project URL slug
component (string) -- Component URL slug
language (string) -- 翻譯語言代碼
也參考
Returned attributes are described in 統計資料.
- GET /api/translations/(string: project)/(string: component)/(string: language)/announcements/¶
在 5.17 版被加入: Returns announcements for a translation.
- param project:
Project URL slug
- type project:
字串
- param component:
Component URL slug
- type component:
字串
- param language:
翻譯語言代碼
- type language:
字串
- >json int id:
ID of the announcement
- >json string message:
announcement text
- >json string severity:
color of the message, one of
info(light blue),warning(yellow),danger(red),success(green)- >json date expiry:
hide after this date, ISO 8601 extended format date (optional)
- >json bool notify:
send notification to subscribed users? (optional)
- POST /api/translations/(string: project)/(string: component)/(string: language)/announcements/¶
在 5.17 版被加入: Creates an announcement for a translation.
- param project:
Project URL slug
- type project:
字串
- param component:
Component URL slug
- type component:
字串
- param language:
翻譯語言代碼
- type language:
字串
- <json string message:
announcement text
- <json string severity:
color of the message, one of
info(light blue),warning(yellow),danger(red),success(green)- <json date expiry:
hide after this date, ISO 8601 extended format date (optional)
- <json bool notify:
send notification to subscribed users? (optional)
- DELETE /api/translations/(string: project)/(string: component)/(string: language)/announcements/(int: announcement_id)/¶
在 5.17 版被加入: Deletes an announcement from a translation.
- param project:
Project URL slug
- type project:
字串
- param component:
Component URL slug
- type component:
字串
- param language:
翻譯語言代碼
- type language:
字串
- param announcement_id:
ID of the announcement to delete
- type announcement_id:
整數
記憶¶
在 4.14 版被加入.
- GET /api/memory/¶
Returns a paginated list of memory results visible to the authenticated user. When no source filter is supplied, the response enumerates all visible entries, including the global shared translation memory. Shared entries contain their source string, translation, and project and component origin. Project access control does not restrict entries explicitly published to shared translation memory; see 共用翻譯記憶.
- Query Parameters:
source -- Case-insensitive substring filter on source text (optional)
source_language -- Source language code filter (optional)
target_language -- Target language code filter (optional)
project -- Project slug filter (optional)
- POST /api/memory/lookup/¶
Looks up translation memory matches for the provided source strings.
- Query Parameters:
source_language -- Source language code
target_language -- Target language code
project -- Project slug filter (optional)
exact -- Return exact matches only and skip fuzzy matching (optional)
- Response JSON Object:
strings (array) -- List of source strings to look up
- Request JSON Object:
results (array) -- Ordered lookup results with the best match for each query or
nullwhen no match was found
- DELETE /api/memory/(int: memory_object_id)/¶
Deletes a memory object
- 參數:
memory_object_id -- Memory Object ID
單元¶
unit 是翻譯中的單一部分,會將來源字串與對應譯文配對,並包含一些相關的中繼資料。此術語源自 Translate Toolkit 及 XLIFF 中的 translate.storage.base.TranslationUnit。
- GET /api/units/¶
Returns a list of translation units.
- 參數:
q (string) -- Search query string 搜尋 (optional)
也參考
Unit object attributes are documented at
GET /api/units/(int:id)/.
- GET /api/units/(int: id)/¶
在 4.3 版的變更: The
targetandsourceare now arrays to properly handle plural strings.在 5.6 版的變更: The
last_updatedattribute is now exposed.在 2026.10 版的變更: The
screenshots_urlattribute is now exposed.Returns information about the translation unit.
- 參數:
id (int) -- Unit ID
- Request JSON Object:
translation (string) -- URL of a related translation object
source (array) -- source string
previous_source (string) -- previous source string used for fuzzy matching
target (array) -- target string
id_hash (string) -- unique identifier of the unit
content_hash (string) -- unique identifier of the source string
location (string) -- location of the unit in source code
context (string) -- translation unit context
note (string) -- translation unit note
flags (string) -- translation unit flags
labels (array) -- translation unit labels, available on source units
state (int) -- unit state, 0 - untranslated, 10 - needs editing, 20 - translated, 30 - approved, 100 - read-only
fuzzy (boolean) -- whether the unit is fuzzy or marked for review
translated (boolean) -- whether the unit is translated
approved (boolean) -- whether the translation is approved
position (int) -- unit position in translation file
has_suggestion (boolean) -- whether the unit has suggestions
has_comment (boolean) -- whether the unit has comments
has_failing_check (boolean) -- whether the unit has failing checks
num_words (int) -- number of source words
priority (int) -- translation priority; 100 is default
id (int) -- unit identifier
tbx_terms (object) -- Read-only TBX metadata with source and target alternative lists. Each record contains text, optional ID, administrative status, and notes with text, origin, category, and scope (concept, language, or term). Empty for other formats.
explanation (string) -- String explanation, available on source units, see 來源字串的額外資訊
extra_flags (string) -- Additional flags for this unit; source flags apply to all languages and translation flags apply only to that language, see 翻譯旗標
web_url (string) -- URL where the unit can be edited
source_unit (string) -- Source unit link; see
GET /api/units/(int:id)/screenshots_url (string) -- URL to list and manage associated screenshots; see
GET /api/units/(int:id)/screenshots/translation_parent (string) -- Read-only link to the configured parent unit, or null when using the component source or the configured parent is missing; see 自訂來源語言
effective_source (array) -- Read-only source text used for translation, including plural forms. The existing
sourcefield continues to contain the canonical file source.effective_previous_source (array) -- Read-only previous source text shown before an effective-source change, including plural forms. The existing
previous_sourcefield retains the canonical file-source value.effective_source_language (string) -- Read-only language code of the effective source, retaining the configured language when its source is missing
pending (boolean) -- whether the unit is pending for write
timestamp (timestamp) -- string age
last_updated (timestamp) -- last string update
- PATCH /api/units/(int: id)/¶
在 4.3 版被加入.
Performs partial update on translation unit.
- 參數:
id (int) -- Unit ID
- Response JSON Object:
state (int) -- unit state, 0 - untranslated, 10 - needs editing, 20 - translated, 30 - approved (need review workflow enabled, see 專門的檢閱者)
target (array) -- target string
explanation (string) -- String explanation, available on source units, see 來源字串的額外資訊
extra_flags (string) -- Additional flags for this unit; source flags apply to all languages and translation flags apply only to that language, see 翻譯旗標
labels (array) -- labels, available on source units
- PUT /api/units/(int: id)/¶
在 4.3 版被加入.
Performs full update on translation unit.
- 參數:
id (int) -- Unit ID
- Response JSON Object:
state (int) -- unit state, 0 - untranslated, 10 - needs editing, 20 - translated, 30 - approved (need review workflow enabled, see 專門的檢閱者)
target (array) -- target string
explanation (string) -- String explanation, available on source units, see 來源字串的額外資訊
extra_flags (string) -- Additional flags for this unit; source flags apply to all languages and translation flags apply only to that language, see 翻譯旗標
labels (array) -- labels, available on source units
- POST /api/units/(int: id)/source/¶
Edit the source string associated with a unit, updating its existing translations within the component. Requires source-editing permission and 管理字串. See 編輯來源字串與索引鍵 for format support and restrictions.
- 參數:
id (int) -- unit ID in any language
- Response JSON Object:
content_hash (integer) -- current content hash of the source unit, required to detect stale edits
source (array) -- replacement source forms, preserving the existing number of forms; optional
context (string) -- replacement key or context; optional
explanation (string) -- source explanation; optional
- Request JSON Object:
object -- updated source unit, in the same format as
GET /api/units/(int:id)/
- Status Codes:
200 OK -- source updated, or the request made no changes
400 Bad Request -- invalid edit, conflicting key, unsupported operation, or stale content hash
403 Forbidden -- editing is not permitted
423 Locked -- component is busy; retry later
Omitted fields remain unchanged. Translation text and associated history are retained. Source-text changes mark translations as needing editing; key-only changes preserve translation states. Files are updated by the normal pending-change queue, respecting the project's commit policy.
- DELETE /api/units/(int: id)/¶
在 4.3 版被加入.
Deletes a translation unit.
- 參數:
id (int) -- Unit ID
- GET /api/units/(int: id)/translations/¶
在 5.11 版被加入.
Returns a list of all target translation units for the given source translation unit.
- GET /api/units/(int: id)/screenshots/¶
在 2026.10 版被加入.
Returns a paginated list of screenshots associated with the unit.
- 參數:
id (int) -- Unit ID
也參考
Screenshot object attributes are documented at
GET /api/screenshots/(int:id)/.
- POST /api/units/(int: id)/screenshots/¶
在 2026.10 版被加入.
Associate screenshot with unit.
- 參數:
id (int) -- Unit ID
- Form Parameters:
string screenshot_id -- Screenshot ID; the screenshot must belong to the same component and language as the unit
也參考
Returns the associated screenshot; see
GET /api/screenshots/(int:id)/.
- DELETE /api/units/(int: id)/screenshots/(int: screenshot_id)¶
在 2026.10 版被加入.
Remove screenshot association with unit.
- 參數:
id (int) -- Unit ID
screenshot_id (int) -- Screenshot ID
- POST /api/units/(int: id)/comments/¶
在 5.12 版被加入.
Create a new comment on the given translation unit.
- 參數:
id (int) -- Unit ID
- Response JSON Object:
scope (string) -- comment scope - global, translation (available on all non-source units), report (need review workflow enabled, see 專門的檢閱者)
comment (string) -- content of the new comment, you can use Markdown and mention users by @username.
user_email (string) -- commenter's email, can be set only by project admins and defaults to the authenticated user.
timestamp (string) -- creation timestamp of the comment, can be set only by project admins and defaults to now.
- Request JSON Object:
id (int) -- comment identifier
comment (string) -- content of the new comment
user (string) -- URL of the commenter's object
timestamp (string) -- creation timestamp of the comment
- GET /api/units/(int: id)/comments/¶
在 5.15 版被加入.
Returns a list of comments on a given translation unit
- 參數:
id (int) -- Unit ID
- Request JSON Object:
id (int) -- comment identifier
comment (string) -- content of the comment
timestamp (string) -- creation timestamp of the comment
user (string) -- URL of the commenter's object
- POST /api/units/(int: id)/suggestions/¶
在 2026.8 版被加入.
Create a new suggestion on the given translation unit.
Requires authentication and the Add suggestion permission on the translation. Suggestions must be enabled on the translation, the translation must not be read-only, and the user must have signed any required contributor agreement.
- 參數:
id (int) -- Unit ID
- Response JSON Object:
target (array) -- suggested translation text as a list of plural forms; use a single-element array for non-plural strings
- Request JSON Object:
id (int) -- suggestion identifier
target (array) -- suggested translation text as a list of plural forms
unit (string) -- URL of the related unit object
user (string) -- URL of the suggester's object
timestamp (string) -- creation timestamp of the suggestion
votes (int) -- net vote count for the suggestion
Users who also have the Vote on suggestion permission automatically upvote their suggestion when it is created.
When the same suggestion already exists from another user and the caller has the Vote on suggestion permission, the existing suggestion is upvoted instead and the response uses the same format as
POST /api/suggestions/(int:id)/vote/(HTTP status 200 instead of 201).
- GET /api/units/(int: id)/suggestions/¶
在 2026.8 版被加入.
Returns a paginated list of suggestions on a given translation unit.
- 參數:
id (int) -- Unit ID
- Request JSON Object:
results (array) -- array of suggestion objects; see
GET /api/suggestions/(int:id)/
建議¶
- GET /api/suggestions/¶
在 2026.8 版被加入.
Returns a paginated list of suggestions the user has access to, ordered by creation time (most recent first).
也參考
Suggestion object attributes are documented at
GET /api/suggestions/(int:id)/.- Request JSON Object:
results (array) -- array of suggestion objects; see
GET /api/suggestions/(int:id)/
- GET /api/suggestions/(int: id)/¶
在 2026.8 版被加入.
Returns information about a suggestion.
- 參數:
id (int) -- Suggestion ID
- Request JSON Object:
id (int) -- suggestion identifier
target (array) -- suggested translation text as a list of plural forms
unit (string) -- URL of the related unit object
user (string) -- URL of the suggester's object, or
nullfor anonymous suggestionstimestamp (string) -- creation timestamp of the suggestion
votes (int) -- net vote count for the suggestion
- DELETE /api/suggestions/(int: id)/¶
在 2026.8 版被加入.
Delete or reject a suggestion.
Requires the Delete suggestion permission on the related translation, or ownership of the suggestion.
- 參數:
id (int) -- Suggestion ID
- Response JSON Object:
rejection_reason (string) -- optional reason for rejecting the suggestion
is_spam (boolean) -- whether to report the suggestion as spam
The request body is optional. When
is_spamistrue, the suggestion content is reported to the antispam service.
- POST /api/suggestions/(int: id)/accept/¶
在 2026.8 版被加入.
Accept a suggestion and apply it to the translation unit.
Requires the Accept suggestion permission on the related translation unit.
- 參數:
id (int) -- Suggestion ID
- Response JSON Object:
approve (boolean) -- whether to mark the translation as approved after accepting; requires the Review strings permission and review workflow enabled (see 專門的檢閱者)
- Request JSON Object:
result (string) --
acceptedwhen the suggestion was accepted
- POST /api/suggestions/(int: id)/vote/¶
在 2026.8 版被加入.
Vote for or against a suggestion.
Requires the Vote on suggestion permission and voting enabled on the related translation (see 建議投票).
- 參數:
id (int) -- Suggestion ID
- Response JSON Object:
value (int) --
1to vote for the suggestion or-1to vote against it
- Request JSON Object:
result (string) --
votedwhen the suggestion remains open;acceptedwhen auto-accept applied itsuggestion (object) -- updated suggestion object when
resultisvoted;nullwhenresultisaccepted
變更¶
- GET /api/changes/¶
在 4.1 版的變更: Filtering of changes was introduced in the 4.1 release.
Returns a list of translation changes.
也參考
Change object attributes are documented at
GET /api/changes/(int:id)/.- Query Parameters:
user (string) -- Username of the user to filter by
action (int) -- Action to filter, can be used several times; see 選取的變更事件 for available values
timestamp_after (timestamp) -- ISO 8601 formatted timestamp to list changes after
timestamp_before (timestamp) -- ISO 8601 formatted timestamp to list changes before
- GET /api/changes/(int: id)/¶
Returns information about the translation change.
- 參數:
id (int) -- Change ID
- Request JSON Object:
unit (string) -- URL of a related unit object
translation (string) -- URL of a related translation object
component (string) -- URL of a related component object
user (string) -- URL of a related user object
author (string) -- URL of a related author object
timestamp (timestamp) -- event timestamp
action (int) -- numeric identification of action
action_name (string) -- text description of action
target (string) -- event changed text
old (string) -- previous text
details (object) -- additional details about the change
id (int) -- change identifier
螢幕擷圖¶
- GET /api/screenshots/¶
Returns a list of screenshots.
也參考
Screenshot object attributes are documented at
GET /api/screenshots/(int:id)/.
- GET /api/screenshots/(int: id)/¶
Returns information about the screenshot.
- 參數:
id (int) -- Screenshot ID
- Request JSON Object:
name (string) -- name of a screenshot
repository_filename (string) -- repository path used to match repository-based screenshot updates
translation (string) -- URL of a related translation object
file_url (string) -- URL to download a file; see
GET /api/screenshots/(int:id)/file/units (array) -- link to associated source string information; see
GET /api/units/(int:id)/
- GET /api/screenshots/(int: id)/file/¶
Download the screenshot image.
- 參數:
id (int) -- Screenshot ID
- POST /api/screenshots/(int: id)/file/¶
Replace screenshot image.
- 參數:
id (int) -- Screenshot ID
- Form Parameters:
file image -- Uploaded file
CURL 範例:
curl -X POST \ -F image=@image.png \ -H "Authorization: Token TOKEN" \ http://example.com/api/screenshots/1/file/
- POST /api/screenshots/(int: id)/units/¶
Associate source string with screenshot.
- 參數:
id (int) -- Screenshot ID
- Form Parameters:
string unit_id -- Unit ID
- Request JSON Object:
name (string) -- name of a screenshot
translation (string) -- URL of a related translation object
file_url (string) -- URL to download a file; see
GET /api/screenshots/(int:id)/file/units (array) -- link to associated source string information; see
GET /api/units/(int:id)/
- DELETE /api/screenshots/(int: id)/units/(int: unit_id)¶
Remove source string association with screenshot.
- 參數:
id (int) -- Screenshot ID
unit_id -- Source string unit ID
- POST /api/screenshots/¶
Creates a new screenshot.
- Form Parameters:
file image -- Uploaded file
string name -- Screenshot name
string project_slug -- 專案 slug
string component_slug -- 組件代稱
string language_code -- 語言代碼
string repository_filename -- Optional repository path used to associate later repository updates
- Request JSON Object:
name (string) -- name of a screenshot
repository_filename (string) -- repository path used to match repository-based screenshot updates
translation (string) -- URL of a related translation object
file_url (string) -- URL to download a file; see
GET /api/screenshots/(int:id)/file/units (array) -- link to associated source string information; see
GET /api/units/(int:id)/
- PATCH /api/screenshots/(int: id)/¶
Edit partial information about screenshot.
- 參數:
id (int) -- Screenshot ID
- Request JSON Object:
name (string) -- name of a screenshot
repository_filename (string) -- repository path used to match repository-based screenshot updates
translation (string) -- URL of a related translation object
file_url (string) -- URL to download a file; see
GET /api/screenshots/(int:id)/file/units (array) -- link to associated source string information; see
GET /api/units/(int:id)/
- PUT /api/screenshots/(int: id)/¶
Edit full information about screenshot.
- 參數:
id (int) -- Screenshot ID
- Request JSON Object:
name (string) -- name of a screenshot
repository_filename (string) -- repository path used to match repository-based screenshot updates
translation (string) -- URL of a related translation object
file_url (string) -- URL to download a file; see
GET /api/screenshots/(int:id)/file/units (array) -- link to associated source string information; see
GET /api/units/(int:id)/
- DELETE /api/screenshots/(int: id)/¶
Delete screenshot.
- 參數:
id (int) -- Screenshot ID
Kotlin SDK 組建¶
警告
The Kotlin SDK is available as an alpha release. No compatibility is guaranteed until the final Kotlin SDK is released. Endpoints, build metadata, CDN manifests, and generated resource formats may change without backward compatibility.
[...]
